--
-- Spell ID's used in the addon.
--
jSBSpellID = {
	["autoshot"]			= 75,
	["steadyshot"]			= 56641,
	["cobrashot"] 			= 77767,
	["killcommand"] 		= 34026,
	["chimerashot"]			= 53209,
	["explosiveshot"] 		= 53301,
	["improvedsteadyshot"]		= 53220,
	["serpentsting"]		= 1978,
	["fervor"]			= 82726,
	["blackarrow"]			= 3674,
	["rapidfire"]			= 3045,
	["wyvernsting"]			= 19386,
	["widowvenom"]			= 82654,
	["freezingtrap"]		= 1499,
}

--
-- Bar Positions
--
jSBBarPos = {
	["TOP"]				= 1,
	["BOTTOM"]			= 2,
	["ABOVE"]			= 3, 
	["BELOW"]			= 4,
	["CENTER"]			= 5,
	["LEFT"]			= 6,
	["RIGHT"]			= 7,
}

-- 
-- This is the base configuration for the addon.  Make changes here where you see fit.
--
jSHunterFocusBarCF = {

	["classcolored"] 			= true,			-- color according to class default or false to use your own colors via "barcolor"
	["classcoloredprediction"]		= true,			-- color according to class default or false to use your own colors via "predictionbarcolor"
	["enablehighcolorwarning"]		= true,			-- true to change color if you have too much focus and use colors defined in "barcolorwarninghigh"
	["enableprediction"]			= true,			-- true to show the incoming focus prediction from steady/cobra shot
	["enableautoshotbar"]			= false,			-- show the small bar for timing auto-shots on the bottom of the main focus bar.
	["enableautoshottext"]			= false,			-- Show a time along with the bar for autoshot cooldown?
	["enabletimers"]			= true,			-- should we show timers above and below the bar for tracking buffs/debuffs
	["enabletimerstext"]			= true,			-- should timers also show time for durations / cooldowns
	["enabletimertenths"]			= true,			-- Show a decimal and tenths of seconds under 10 seconds on timer?
	["bartexture"] 				= 'JSSolid',		-- style of the bar texture
	["barfont"]				= 'Default',		-- font to use for your bar
	["barcolor"] 				= {0.6, 0.6, 0.6},	-- main bar color when class coloring is not used
	["barcolorwarninglow"]			= {1, 0, 0},		-- main bar color when focus is below the minimum for your main spell
	["barcolorwarninghigh"]			= {1, 0.55, 0},		-- main bar color when focus is above the high threshold
	["predictionbarcolorwarninghigh"]	= {1, 0.55, 0},		-- main prediction bar color when focus is above the high threshold
	["predictionbarcolor"]			= {0.6, 0.6, 0.6},	-- bar color when class coloring is not used for the incoming focus prediction
	["autoshotbarcolor"]			= {1, 1, 1},		-- bar color when class coloring is not used for the incoming focus prediction
	["focushighthreshold"] 			= 0.8,			-- threshold value used to determine when to change bar color for too much focus
	["alphabackdrop"] 			= 0.5,			-- alpha value for the bar texture backdrop (the bar thingy)
	["alphazeroooc"] 			= 0, 			-- zero focus ooc, probably means we are in a vehicle or under an effect
	["alphamaxooc"] 			= 0.1,			-- max focus ooc alpha value (I prefer to barely see the bar when ooc)
	["alphanormooc"] 			= 0.5,			-- alpha ooc for when you are regenerating focus ooc and your are not at zero or focus max
	["alphazero"] 				= 0.1, 			-- alpha for zero focus in combat, probably means you are in a vehicle or under an effect
	["alphamax"] 				= 0.9,			-- alpha for bar when in combat and have max focus
	["alphanorm"] 				= 0.9,			-- in combat normal alpha value, this is basically what you see when fighting in combat
	["updateinterval"] 			= 0.1,			-- alpha ooc for when you are regenerating focus ooc and your are not at zero or focus max
	["fontsize"] 				= 17,			-- font size for your current focus
	["fontsizetimers"]			= 13,			-- font size for the cooldowns on the timers, if enabled
	["fontoutined"] 			= true,			-- should the current focus font be outlined (makes it easier to see in most cases)
	["timerfontposition"]			= jSBBarPos.RIGHT,	-- position of the cooldown / duration for timer icons
									--  If you specify top or bottom, the addon will position the text on the
									--  proper outter most side (top or bottom) accordingly.  This means that if 
									--  you specify TOP for a bottom bar timer, it will make it BOTTOM automatically.
}

-- Timers below have 4 fields, quantity is unlimited.  You can, in essence, have durations on top, cooldowns on bottom, etc.
--   the possibilities are now limitless on how you want your own configuration to look.
--
--  1st field = spell ID
--  2nd field = true to track duration up or false for cooldown
--  3rd field = true for player false for target
--  4th field = position of the icon relative to the bar

jSHunterFocusBarTimers = {
	["bm"] = {
		{ jSBSpellID.serpentsting, 	true, 	false, 	jSBBarPos.ABOVE },
		{ jSBSpellID.widowvenom,	 	true, 	false, 	jSBBarPos.ABOVE },
		{ jSBSpellID.rapidfire, 		true, 	true, 	jSBBarPos.ABOVE },
		{ jSBSpellID.fervor, 		false, 	true, 	jSBBarPos.BELOW },
		{ jSBSpellID.freezingtrap,		false, 	true, 	jSBBarPos.BELOW },
	},

	["mm"] = {
		{ jSBSpellID.improvedsteadyshot, 	true, 	true, 	jSBBarPos.ABOVE },
		{ jSBSpellID.serpentsting, 	true, 	false, 	jSBBarPos.ABOVE },
		{ jSBSpellID.widowvenom,	 	true, 	false, 	jSBBarPos.ABOVE },
		{ jSBSpellID.rapidfire, 		true, 	true, 	jSBBarPos.ABOVE },
		{ jSBSpellID.freezingtrap,		false, 	true, 	jSBBarPos.BELOW },
	},

	["sv"] = {
		{ jSBSpellID.blackarrow, 		false, 	true, 	jSBBarPos.ABOVE },
		{ jSBSpellID.serpentsting, 	true, 	false, 	jSBBarPos.ABOVE },
		{ jSBSpellID.rapidfire, 		true, 	true, 	jSBBarPos.ABOVE },
		{ jSBSpellID.widowvenom,	 	true, 	false, 	jSBBarPos.ABOVE },
		{ jSBSpellID.wyvernsting, 		false, 	true, 	jSBBarPos.BELOW },
		{ jSBSpellID.freezingtrap,		false, 	true, 	jSBBarPos.BELOW },
		{ jSBSpellID.explosiveshot,	false, 	true, 	jSBBarPos.CENTER }, -- If you want an esplosive shot timer on the main bar, remove the "--" at the start of this line.
	}
}

-- The textures available to us for use on the bar
jSBBarTextures = {
	["Blizzard"] = [=[Interface\TargetingFrame\UI-StatusBar]=],
	["JSSolid"] = [=[Interface\AddOns\JSHunterFocusBar\JSSolid.tga]=],
}
