--
-- JS' Hunter Focus Bar
--
-- US - Blackhand - Alliance (Js)
--
-- www.transcended.us for support
--

local ver = "1.53"

-- Check if character is a hunter, if not abort.
if select(2, UnitClass("player")) ~= "HUNTER" then return end

-- Show slash command
print("JS' Hunter Bar " .. ver .. "loaded, type /jsb for help.")

jSHunterFocusBar = CreateFrame("StatusBar", "jSHunterFocusBarMainFrame", UIParent)
local frame = jSHunterFocusBar

--
-- Idiot proofing...  Do I really need to explain this?
--
if jSHunterFocusBarCF.timerfontposition == jSBBarPos.ABOVE then jSHunterFocusBarCF.timerfontposition = jSBBarPos.TOP end
if jSHunterFocusBarCF.timerfontposition == jSBBarPos.BELOW then jSHunterFocusBarCF.timerfontposition = jSBBarPos.BOTTOM end
if jSHunterFocusBarCF.timerfontposition == jSBBarPos.LEFT then jSHunterFocusBarCF.timerfontposition = jSBBarPos.RIGHT end

--
-- Recognized Slash commands
--
SLASH_jSHunterFocusBar1 	= "/jsb"
SLASH_jSHunterFocusBar2 	= "/jshfb"
SLASH_jSHunterFocusBar3 	= "/jsbar"

--
-- Misc. Variables
--
local specs				= { "bm", "mm", "sv" } 	-- in order
local jSHunterFocusBarFont 		= "Interface\\AddOns\\JSHunterFocusBar\\focusbar_font.ttf"
local classColors			= { RAID_CLASS_COLORS[select(2, UnitClass("player"))].r, RAID_CLASS_COLORS[select(2, UnitClass("player"))].g, RAID_CLASS_COLORS[select(2, UnitClass("player"))].b }
local barLocked 			= true
local powerMax 				= 0
local lastUpdate 			= 0
local combatActive 			= false
local isCasting 			= false
local predictionAdjustment		= 0			-- We need to modify the amount to Predict, based on talents, procs, etc.
local terminationBase			= 3 			-- Base per point value for Termination talent
local predictionSpell 			= 9			-- Incoming focus base for prediction
local autoShotStartTime			= 0
local autoShotEndTime			= 0
local jSHunterFocusBarTick		= nil
local tickmin				= nil
local currentPower			= 0
local jSHunterFocusBarTimerFrames  	= { }
local spellCastID			= 0
local currentTree			= 0
local iconSize				= 0
local time				= 0
local mainSpell				= 0
local barColor				= { 0, 0, 0 }
local tempVars				= { }			-- reusable variables to reduce creating too many locals, undescriptive, but better for memory
local f 				= nil			-- temorary reusable for frames creation


-- Check for Deuff on target unit, cast by player
local function checkForTargetDebuff(spellID)
	time = GetTime()
	tempVars[1], _, _, _, _, tempVars[2], tempVars[3] = UnitAura("target", GetSpellInfo(spellID), nil, "PLAYER|HARMFUL")
	return tempVars[1] and true or false, tempVars[1] and tempVars[2] or 0, (tempVars[1] and (tempVars[3] - time) > 0) and math.max(tempVars[3] - time, 0) or 0
end


-- Check for Buff or Cooldown of ability on player unit, cast by player - getDuration = true for duration, false for CD
local function checkForPlayerBuff(spellID, getDuration)
	if getDuration then
		time = GetTime()
		tempVars[1], _, _, _, _, tempVars[2], tempVars[3] = UnitAura("player", GetSpellInfo(spellID), nil, "PLAYER|HELPFUL")
		return tempVars[1] and true or false, tempVars[1] and tempVars[2] or 0, tempVars[1] and math.max(tempVars[3] - time, 0) or 0
	else
		time = GetTime()
		tempVars[1], tempVars[2] = GetSpellCooldown(spellID)

		-- Need to hack this code a bit, because if we are on GCD it will trigger this to have a duration.
		-- Assuming the duration cannot be less than 2, we can override the issues with a simple hack.

		if tempVars[2] > 2 then
			return tempVars[2] == 0 and false or true, tempVars[2] == 0 and 0 or tempVars[2], tempVars[2] == 0 and 0 or math.max(tempVars[1] + tempVars[2] - time, 0)
		else
			return false, 0, 0 -- easy!
		end
	end
end


local function getIconOffset(whichPos)
	iconSize = frame.db.iconSize > 0 and (frame.db.iconSize) or (frame:GetHeight())

	if whichPos == jSBBarPos.TOP or whichPos == jSBBarPos.RIGHT then
		return ((frame:GetHeight() / 2) + 2) -- +2 for the border from the bar's inset
	elseif whichPos == jSBBarPos.BOTTOM or whichPos == jSBBarPos.LEFT then
		return (-((frame:GetHeight() / 2) + 2))
	elseif whichPos == jSBBarPos.ABOVE then
		return ((frame:GetHeight() / 2) + (iconSize/2) + 3) -- +3 for border from inset + 1 px spacing
	elseif whichPos == jSBBarPos.BELOW then
		return (-((frame:GetHeight() / 2) + (iconSize/2) + 3))
	elseif whichPos == jSBBarPos.CENTER then
		return 0
	end
end


local function getTimerXPos(durationLeft, durationMax)
	iconSize = frame.db.iconSize > 0 and (frame.db.iconSize) or (frame:GetHeight())
	return ((((durationLeft / durationMax) * 100) * (((frame:GetWidth() - (iconSize*2)) + 4) / 100)) - 2) -- the -4 and -2 are taking the borders into account
end


local function formatTimeText(val)
	if (val >= 3600) then
		return tostring(math.floor(val / 3600)) .. " h";
	elseif (val >= 60 ) then
		return tostring(math.floor(val / 60)) .. " m";
	elseif (val > 10) then
		return tostring(math.floor(val));
	elseif (val > 0) then
		if jSHunterFocusBarCF.enabletimertenths then
			return tostring(math.floor(val * 10) / 10);
		else
			return tostring(math.floor(val));
		end
	end
end


local function setIconTimers()
	iconSize = frame.db.iconSize > 0 and (frame.db.iconSize) or (frame:GetHeight())
	currentTree = GetPrimaryTalentTree() -- 3 = sv, 2 = mm, 1 = bm
	
	if currentTree == nil then currentTree = 1 end

	-- Create the frames we need dynamically.
	for i=1,#jSHunterFocusBarTimers[specs[currentTree]] do

		f = CreateFrame("Frame", nil, frame)

		f.t=f:CreateTexture(nil,"OVERLAY")
		f.t:SetTexture(select(3, GetSpellInfo(jSHunterFocusBarTimers[specs[currentTree]][i][1])))
		f.t:SetBlendMode("ALPHAKEY")

		f.t:SetWidth(iconSize)
		f.t:SetHeight(iconSize)
		f.t:SetPoint("LEFT", frame, "LEFT", 0, getIconOffset(jSHunterFocusBarTimers[specs[currentTree]][i][4]))
		f.t:Show()
		f.t:SetAlpha(0)
		f.t.value = frame:CreateFontString(nil, "OVERLAY", self)
		f.t.value:SetJustifyH("MIDDLE")
		f.t.value:SetJustifyV("MIDDLE")
		f.t.value:SetFont(jSHunterFocusBarFont, jSHunterFocusBarCF.fontsizetimers, "OUTLINE")
		f.t.value:SetTextColor(1, 1, 1)
		f.t.value:SetAlpha(0)

		jSHunterFocusBarTimerFrames[i] = f
	end
end


-- Cleans up the timer frames created for situations like talent spec change, etc. because there may be more or less timers defined upon change.
local function destroyIconTimers()
	for i=1,#jSHunterFocusBarTimerFrames do
		jSHunterFocusBarTimerFrames[i].t.value:SetAlpha(0)
		jSHunterFocusBarTimerFrames[i].t:SetAlpha(0)
		jSHunterFocusBarTimerFrames[i] = nil
	end
end


local function getAuraInfo(alias)
	if alias[2] and alias[3] then -- get duration left on player
		return checkForPlayerBuff(alias[1], true)
	elseif alias[2] and not alias[3] then -- get duration left on target
		return checkForTargetDebuff(alias[1])
	else -- get cooldown left, assume player and not target
		return checkForPlayerBuff(alias[1], false)
	end
end

--
-- Update the timer frames dynamically
--
local function updateTimers()
	currentTree = GetPrimaryTalentTree()
	iconSize = frame.db.iconSize > 0 and (frame.db.iconSize) or (frame:GetHeight())

	if currentTree == nil then currentTree = 1 end

	for i=1,#jSHunterFocusBarTimers[specs[currentTree]] do
		tempVars[1], tempVars[2], tempVars[3] = getAuraInfo(jSHunterFocusBarTimers[specs[currentTree]][i])

		if tempVars[1] and (not UnitIsDeadOrGhost("player")) then 
			jSHunterFocusBarTimerFrames[i].t:SetPoint("LEFT", frame, "LEFT", getTimerXPos(tempVars[3], tempVars[2]),  getIconOffset(jSHunterFocusBarTimers[specs[currentTree]][i][4]))

			if jSHunterFocusBarCF.timerfontposition == jSBBarPos.TOP or jSHunterFocusBarCF.timerfontposition == jSBBarPos.BOTTOM then

				if (jSHunterFocusBarTimers[specs[currentTree]][i][4] == jSBBarPos.TOP) or (jSHunterFocusBarTimers[specs[currentTree]][i][4] == jSBBarPos.ABOVE) or 
					((jSHunterFocusBarTimers[specs[currentTree]][i][4] == jSBBarPos.CENTER) and (jSHunterFocusBarCF.timerfontposition == jSBBarPos.TOP)) then

					jSHunterFocusBarTimerFrames[i].t.value:SetPoint("BOTTOM", jSHunterFocusBarTimerFrames[i].t, "TOP", 0,  1)
				else
					jSHunterFocusBarTimerFrames[i].t.value:SetPoint("TOP", jSHunterFocusBarTimerFrames[i].t, "BOTTOM", 0, 1)
				end
			elseif jSHunterFocusBarCF.timerfontposition == jSBBarPos.RIGHT then
				jSHunterFocusBarTimerFrames[i].t.value:SetPoint("LEFT", jSHunterFocusBarTimerFrames[i].t, "RIGHT", 1,  0)
			else
				jSHunterFocusBarTimerFrames[i].t.value:SetPoint("CENTER", jSHunterFocusBarTimerFrames[i].t, "CENTER", 0, 0)
			end

			jSHunterFocusBarTimerFrames[i].t.value:SetText(formatTimeText(tempVars[3]))
			jSHunterFocusBarTimerFrames[i].t.value:SetAlpha(1)
			jSHunterFocusBarTimerFrames[i].t:SetAlpha(.7) 
		elseif (jSHunterFocusBarTimerFrames[i] ~= nil) and (jSHunterFocusBarTimerFrames[i].t ~= nil) then
			jSHunterFocusBarTimerFrames[i].t:SetAlpha(0)
			jSHunterFocusBarTimerFrames[i].t.value:SetAlpha(0)
		end
	end
end


local function getMainSpell()
	currentTree = GetPrimaryTalentTree()

	if currentTree == nil then currentTree = 1 end
	
	if currentTree == 3 then
		return select(4, GetSpellInfo(jSBSpellID.explosiveshot)), jSBSpellID.explosiveshot
	elseif currentTree == 2 then
		return select(4, GetSpellInfo(jSBSpellID.chimerashot)), jSBSpellID.chimerashot
	else
		return select(4, GetSpellInfo(jSBSpellID.killcommand)), jSBSpellID.killcommand
	end
end


local function setTicks()
	if jSHunterFocusBarTick then
		jSHunterFocusBarTick:Hide()
		jSHunterFocusBarTick:SetParent(nil)
		jSHunterFocusBarTick = nil
	end

	jSHunterFocusBarTick = CreateFrame("Frame", nil, frame)

	tickMin	= jSHunterFocusBarTick:CreateTexture(nil,"OVERLAY")
	tickMin:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	tickMin:SetWidth(10)
	tickMin:SetBlendMode("ADD")
	tickMin:SetHeight(frame:GetHeight() * 1.85)
end


local function updatePredictionAdjustment()
	-- Account for Termination talent extra focus
	if UnitHealth("target") / UnitHealthMax("target") <= 0.25 then 
		predictionAdjustment = select(5, GetTalentInfo(2, 12)) * terminationBase
	else
		predictionAdjustment = 0
	end
end

local function getPredictionColor()
	currentPower = UnitPower("player")

	-- class colored prediction is turned on
	if jSHunterFocusBarCF.classcoloredprediction then

		if jSHunterFocusBarCF.enablehighcolorwarning and ((currentPower / powerMax) >= jSHunterFocusBarCF.focushighthreshold) then
			-- class colored but over high threshold
			return jSHunterFocusBarCF.predictionbarcolorwarninghigh
		else
			-- class colored not over high threshold or high threshold is turned off
			return classColors
		end

	-- class colored prediction is not turned on
	elseif jSHunterFocusBarCF.enablehighcolorwarning and ((currentPower / powerMax) >= jSHunterFocusBarCF.focushighthreshold) then

		-- over the threshold enabled, set to the high warning color	
		return jSHunterFocusBarCF.predictionbarcolorwarninghigh
	else
		-- not over threshold, set color to the hard-defined color because class colored prediction is not on		
		return jSHunterFocusBarCF.predictionbarcolor
	end
end


local function getBarColor()
	currentPower = UnitPower("player")

	-- class colored is turned on
	if jSHunterFocusBarCF.classcolored then
		if jSHunterFocusBarCF.enablehighcolorwarning and ((currentPower / powerMax) >= jSHunterFocusBarCF.focushighthreshold) then
			-- class colored but over high threshold
			return jSHunterFocusBarCF.barcolorwarninghigh
		else
			-- class colored not over high threshold or high threshold is turned off
			return classColors
		end
	-- class colored is not turned on
	elseif jSHunterFocusBarCF.enablehighcolorwarning and ((currentPower / powerMax) >= jSHunterFocusBarCF.focushighthreshold) then
		-- over the threshold enabled, set to the high warning color	
		return jSHunterFocusBarCF.barcolorwarninghigh
	else
		-- not over threshold, set color to the hard-defined color because class colored is not on		
		return jSHunterFocusBarCF.barcolor
	end
end


local function setPrediction()
	barColor = getPredictionColor()
	currentPower = UnitPower("player")

	if jSHunterFocusBarPrediction then
		jSHunterFocusBarPrediction:Hide()
		jSHunterFocusBarPrediction:SetParent(nil)
		jSHunterFocusBarPrediction = nil
	end

	jSHunterFocusBarPrediction = CreateFrame("StatusBar", nil, frame)

	jSHunterFocusBarPrediction:SetStatusBarTexture(frame:GetStatusBarTexture():GetTexture()) -- Use the main bar's texture
	jSHunterFocusBarPrediction:SetMinMaxValues(0, 1)
	jSHunterFocusBarPrediction:SetValue(1)
	jSHunterFocusBarPrediction:SetFrameLevel(frame:GetFrameLevel())
   
	updatePredictionAdjustment()

	jSHunterFocusBarPrediction:SetSize((frame:GetWidth() / 100) * (predictionSpell + predictionAdjustment), frame:GetHeight())
   
	jSHunterFocusBarPrediction:SetAlpha(0) -- hide

	if (currentPower + predictionSpell + predictionAdjustment) <= powerMax then
		jSHunterFocusBarPrediction:SetStatusBarColor(barColor[1], barColor[2], barColor[3], 1)
	else
		jSHunterFocusBarPrediction:SetSize((frame:GetWidth() / 100) * (powerMax - currentPower), frame:GetHeight())		
		jSHunterFocusBarPrediction:SetStatusBarColor(jSHunterFocusBarCF.barcolorwarninglow[1], jSHunterFocusBarCF.barcolorwarninglow[2], jSHunterFocusBarCF.barcolorwarninglow[3])
	end
end


local function setAutoShot()
	currentPower = UnitPower("player")

	if jSHunterFocusBarAutoShot then
		jSHunterFocusBarAutoShot:Hide()
		jSHunterFocusBarAutoShot:SetParent(nil)
		jSHunterFocusBarAutoShot = nil
	end

	jSHunterFocusBarAutoShot = CreateFrame("StatusBar", nil, frame)

	jSHunterFocusBarAutoShot:SetStatusBarTexture(frame:GetStatusBarTexture():GetTexture()) -- Use the main bar's texture
	jSHunterFocusBarAutoShot:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 0, 0) -- 2px up from bottom to be withing the main status bar
	jSHunterFocusBarAutoShot:SetMinMaxValues(0, UnitRangedDamage("player"))
	jSHunterFocusBarAutoShot:SetSize(frame.db.barWidth, 2) -- 2px in height (Don't want this to be annoying!)
	jSHunterFocusBarAutoShot:SetValue(UnitRangedDamage("player"))
	jSHunterFocusBarAutoShot:SetFrameLevel(frame:GetFrameLevel() + 1) -- raise strata one level so this is above the main bar
		
	jSHunterFocusBarAutoShot:SetStatusBarColor(jSHunterFocusBarCF.autoshotbarcolor[1], jSHunterFocusBarCF.autoshotbarcolor[2], jSHunterFocusBarCF.autoshotbarcolor[3])
	jSHunterFocusBarAutoShot:SetAlpha(0) -- hide

	jSHunterFocusBarAutoShot.value = jSHunterFocusBarAutoShot:CreateFontString(nil, "OVERLAY")
	jSHunterFocusBarAutoShot.value:SetFont(jSHunterFocusBarFont, jSHunterFocusBarCF.fontsizetimers, "OUTLINE")
	jSHunterFocusBarAutoShot.value:SetTextColor(1, 1, 1)
	jSHunterFocusBarAutoShot.value:SetPoint("BOTTOMRIGHT", jSHunterFocusBarAutoShot, "BOTTOMRIGHT", 1, 0)
	jSHunterFocusBarAutoShot.value:SetJustifyH("BOTTOM")
end


local function updatePrediction()
	if not isCasting then return end -- No need to update if not casting

	barColor	= getPredictionColor()
	tempVars[1] 	= select(2, frame:GetMinMaxValues())
	tempVars[2] 	= frame:GetWidth() / (tempVars[1] / frame:GetValue())
	currentPower 	= UnitPower("player")

	updatePredictionAdjustment()

	jSHunterFocusBarPrediction:SetSize((frame:GetWidth() / 100) * (predictionSpell + predictionAdjustment), frame:GetHeight())

	jSHunterFocusBarPrediction:ClearAllPoints()
	jSHunterFocusBarPrediction:SetPoint("LEFT", frame, "LEFT", tempVars[2], 0)

	if (currentPower + predictionSpell + predictionAdjustment) <= powerMax then
		if (currentPower + predictionSpell + predictionAdjustment) >= mainSpell then
			jSHunterFocusBarPrediction:SetStatusBarColor(barColor[1], barColor[2], barColor[3], 1)
		else
			jSHunterFocusBarPrediction:SetStatusBarColor(jSHunterFocusBarCF.barcolorwarninglow[1], jSHunterFocusBarCF.barcolorwarninglow[2], jSHunterFocusBarCF.barcolorwarninglow[3], 1)
		end
	else
		jSHunterFocusBarPrediction:SetSize((frame:GetWidth() / 100) * (powerMax - currentPower), frame:GetHeight())
		jSHunterFocusBarPrediction:SetStatusBarColor(jSHunterFocusBarCF.barcolorwarninglow[1], jSHunterFocusBarCF.barcolorwarninglow[2], jSHunterFocusBarCF.barcolorwarninglow[3], 1)
	end

	if ((powerMax - currentPower) > 0) and (not UnitIsDeadOrGhost("player")) then
		jSHunterFocusBarPrediction:SetAlpha(frame:GetAlpha() * 0.5) -- Show prediction
	else
		jSHunterFocusBarPrediction:SetAlpha(0) -- Hide prediction
	end
end


local function updateAutoShot()
	currentTime = GetTime()
	currentPower = UnitPower("player")

	if currentTime > autoShotEndTime then
		jSHunterFocusBarAutoShot:SetAlpha(0) -- Hide
	else
		jSHunterFocusBarAutoShot:SetValue(autoShotStartTime + (currentTime - autoShotStartTime))
		jSHunterFocusBarAutoShot.value:SetFormattedText("%.1f", autoShotEndTime - currentTime)
	
		if not UnitIsDeadOrGhost("player") then
			jSHunterFocusBarAutoShot:SetAlpha(frame:GetAlpha()) -- Show it
		else
			jSHunterFocusBarAutoShot:SetAlpha(0) -- Hide
		end
	end
end


function frame:CreateFrame()
	frame:SetStatusBarTexture(jSBBarTextures[jSHunterFocusBarCF.bartexture])
	frame:SetMinMaxValues(0, 1)
	frame:SetValue(0)

	frame.backdrop = frame:CreateTexture(nil, "BACKGROUND", frame)
	frame.backdrop:SetPoint("TOPLEFT", -2, 2)
	frame.backdrop:SetPoint("BOTTOMRIGHT", 2, -2)
	frame.backdrop:SetTexture(0, 0, 0, .5)
	
	frame.value = frame:CreateFontString(nil, "OVERLAY", frame)
	frame.value:SetPoint("CENTER", frame, "CENTER", 0, (jSHunterFocusBarCF.enableautoshotbar == true) and 2 or 0)
	frame.value:SetJustifyH("CENTER")

	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
end


SlashCmdList.jSHunterFocusBar = function(msg, editbox)
	tempVars[1], tempVars[2] = msg:match("^(%S*)%s*(.-)$");
	tempVars[1] = tempVars[1]:lower()

	if tempVars[1] == "" then
		if not debug then
			print("JS' Hunter Bar " .. ver .. " settings")
			print("/jsb lock - Lock or unlock bar's position")
			print("/jsb width 'val' - Set width of the bar to 'val'")
			print("/jsb height 'val' - Set height of the bar")
			print("/jsb iconsize 'val' - Set timer icon's size (0 = default)")
			print("Current Width: " .. frame.db.barWidth .. ", Current Height: " .. frame.db.barHeight)
			print("Current Icon Size: " .. frame.db.iconSize)
		else
			print("Debug Info: N/A")
		end
	elseif tempVars[1] == "lock" or tempVars[1] == "unlock" or tempVars[1] == "drag" or tempVars[1] == "move" then
		barLocked = not barLocked
		frame:ApplyLock()

	elseif tempVars[1] == "width" or tempVars[1] == "w" then
		if tonumber(tempVars[2]) ~= nil and tonumber(tempVars[2]) >= 50 and tonumber(tempVars[2]) <= 900 then
			frame.db.barWidth = tonumber(tempVars[2])
			destroyIconTimers()
			frame:ApplyOptions()
			print("JS' Hunter Bar width set to: " .. frame.db.barWidth)
		else
			print("JSB: Invalid input format.")

		end
	elseif tempVars[1] == "height" or tempVars[1] == "h" then
		if tonumber(tempVars[2]) ~= nil and tonumber(tempVars[2]) >= 10 and tonumber(tempVars[2]) <= 500 then
			frame.db.barHeight = tonumber(tempVars[2])
			destroyIconTimers()
			frame:ApplyOptions()
			print("JS' Hunter Bar height set to: " .. frame.db.barHeight)
		else
			print("JSB: Invalid input format.")
		end
	elseif tempVars[1] == "iconsize" or tempVars[1] == "isize" then
		if tonumber(tempVars[2]) ~= nil and (tonumber(tempVars[2]) >= 8 and tonumber(tempVars[2]) <= 200) or (tonumber(tempVars[2]) == 0) then
			frame.db.iconSize = tonumber(tempVars[2])
			destroyIconTimers()
			frame:ApplyOptions()
			print("JS' Hunter Bar icon size set to: " .. frame.db.iconSize)
		else
			print("JSB: Invalid input format.")
		end
	elseif tempVars[1] == "reset" then
		frame.db.barWidth		= 250
		frame.db.barHeight		= 19			
		frame.db.anchorPoint 		= "CENTER" 
		frame.db.anchorPointRelative 	= "CENTER"
		frame.db.anchorPointOffsetX 	= 0 
		frame.db.anchorPointOffsetY 	= -170
		frame.db.iconSize	 	= 0

		destroyIconTimers()
		frame:ApplyOptions()

		print("JS' Hunter Bar has been set to default size and position.")
	else
		print("JSB: Invalid input format.")
	end
end


function frame:ApplyLock()
	if barLocked then
		print("JS' Hunter Bar is now locked in position.")

		tempVars[1], _, tempVars[2], tempVars[3], tempVars[4] = frame:GetPoint()

		frame.db.anchorPoint 		= tempVars[1]
		frame.db.anchorPointRelative 	= tempVars[2]
		frame.db.anchorPointOffsetX 	= tempVars[3]
		frame.db.anchorPointOffsetY 	= tempVars[4]

		frame:StopMovingOrSizing()
		
		frame:SetMovable(false)
		frame:EnableMouse(false)
		frame:RegisterForDrag()
	else
		print("JS' Hunter Bar is now unlocked and movable, type '/jsb lock' to re-lock.")
		frame:SetAlpha(1)

		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:RegisterForDrag("LeftButton")
	end
end


function frame:ApplyOptions()
	barColor = getBarColor()
	
	frame.backdrop:SetTexture(0, 0, 0, jSHunterFocusBarCF.alphabackdrop)
	frame:SetStatusBarTexture(jSBBarTextures[jSHunterFocusBarCF.bartexture])
	frame:SetMinMaxValues(0, UnitPowerMax("player") and UnitPowerMax("player") or 100)
	
	frame:SetStatusBarColor(barColor[1], barColor[2], barColor[3])
	frame:SetPoint(frame.db.anchorPoint, 'UIParent', frame.db.anchorPointRelative, frame.db.anchorPointOffsetX, frame.db.anchorPointOffsetY)
	frame:SetSize(frame.db.barWidth, frame.db.barHeight)

	frame.value:SetFont(jSHunterFocusBarFont, jSHunterFocusBarCF.fontsize, jSHunterFocusBarCF.fontoutined and "OUTLINE" or "")

	frame.value:SetTextColor(1, 1, 1)

	setTicks()
	if jSHunterFocusBarCF.enableautoshotbar then setAutoShot() end
	if jSHunterFocusBarCF.enableprediction then setPrediction() end
	if jSHunterFocusBarCF.enabletimers then setIconTimers() end
end


local function updateJSHunterFocusBar()
	barColor = getBarColor()
	tempVars[1] = frame:GetWidth() / select(2, frame:GetMinMaxValues())

	currentPower = UnitPower("player")
	mainSpell = getMainSpell()

	frame:SetValue(currentPower)
	frame.value:SetText(currentPower)

	if (currentPower == 0) or (UnitIsDeadOrGhost("player")) then
		if barLocked then 
			frame:SetAlpha(combatActive and jSHunterFocusBarCF.alphazero or jSHunterFocusBarCF.alphazeroooc) 
		end
	else
		if currentPower == powerMax then
			if barLocked then 
				frame:SetAlpha(combatActive and jSHunterFocusBarCF.alphamax or jSHunterFocusBarCF.alphamaxooc)
			end
		else
			if barLocked then frame:SetAlpha(combatActive and jSHunterFocusBarCF.alphanorm or jSHunterFocusBarCF.alphanormooc) end
		end
	end
	
	-- May need to abort tick update if a proc happens, but the Tick should move to reflect - at least thats my thinking.
	tickMin:SetPoint("LEFT", frame, "LEFT", mainSpell * tempVars[1] - 5, 0)

	if currentPower >= mainSpell then
		tickMin:SetVertexColor(barColor[1], barColor[2], barColor[3])
		frame:SetStatusBarColor(barColor[1], barColor[2], barColor[3]) -- Class colored or defined color.
	else
		tickMin:SetVertexColor(jSHunterFocusBarCF.barcolorwarninglow[1], jSHunterFocusBarCF.barcolorwarninglow[2], jSHunterFocusBarCF.barcolorwarninglow[3])
		frame:SetStatusBarColor(jSHunterFocusBarCF.barcolorwarninglow[1], jSHunterFocusBarCF.barcolorwarninglow[2], jSHunterFocusBarCF.barcolorwarninglow[3])
	end

	tickMin:Show()
end


--
-- Register our frame events.
--
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent('UNIT_CONNECTION')
frame:RegisterEvent('UNIT_MAXPOWER')
frame:RegisterEvent("UNIT_POWER")
frame:RegisterEvent("UNIT_SPELLCAST_START")
frame:RegisterEvent("UNIT_SPELLCAST_STOP")
frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
frame:RegisterEvent("UNIT_SPELLCAST_FAILED")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("PLAYER_REGEN_DISABLED")
frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")


frame:SetScript("OnUpdate", function(self, elapsedTime)
	lastUpdate = lastUpdate + elapsedTime

	if lastUpdate > jSHunterFocusBarCF.updateinterval then
		lastUpdate = 0
		updateJSHunterFocusBar()
		if jSHunterFocusBarCF.enableprediction then updatePrediction() end
		if jSHunterFocusBarCF.enabletimers then updateTimers() end
		if jSHunterFocusBarCF.enableautoshotbar then updateAutoShot() end
	end
end)


frame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		local addon = ...
		if addon:lower() ~= "jshunterfocusbar" then return end

		JSHunterFocusBar = JSHunterFocusBar or {
			barWidth		= 250,
			barHeight		= 19,			
			anchorPoint 		= "CENTER", 
			anchorPointRelative 	= "CENTER",
			anchorPointOffsetX 	= 0, 
			anchorPointOffsetY 	= -170,
			iconSize		= 0, -- Zero is default auto-scaling to width/height = 1/2 bar height
		}

		-- Account for new variables added after release
		if JSHunterFocusBar.iconSize == nil then JSHunterFocusBar.iconSize = 0 end

		self.db = JSHunterFocusBar
	
		self:CreateFrame()

		self:UnregisterEvent("ADDON_LOADED")

	elseif event == "UNIT_SPELLCAST_START" then
		if select(1, ...) == "player" then
			spellCastID = select(5, ...)
			if spellCastID  == jSBSpellID.steadyshot or spellCastID == jSBSpellID.cobrashot then
				isCasting = true
				if jSHunterFocusBarCF.enableprediction then
					updatePrediction()
				end
			elseif spellCastID == jSBSpellID.autoshot then
				updateAutoShot()
			end
		end
	elseif string.find(event, "UNIT_SPELLCAST_") then -- STOP / FAILED / SUCCEEDED all handled here
		if select(1, ...) == "player" then
			spellCastID = select(5, ...)
			if spellCastID  == jSBSpellID.steadyshot or spellCastID == jSBSpellID.cobrashot then
				isCasting = false
				if jSHunterFocusBarCF.enableprediction then
					jSHunterFocusBarPrediction:SetAlpha(0) -- Hide prediction
					return
				end
			end
			if (event == "UNIT_SPELLCAST_SUCCEEDED") and (spellCastID == jSBSpellID.autoshot) and jSHunterFocusBarCF.enableautoshotbar then
				autoShotStartTime = GetTime()
				autoShotEndTime	= autoShotStartTime + UnitRangedDamage("player")

				jSHunterFocusBarAutoShot:SetMinMaxValues(autoShotStartTime, autoShotEndTime)
				jSHunterFocusBarAutoShot.value:SetText("")
				jSHunterFocusBarAutoShot:SetAlpha(frame:GetAlpha()) -- Same alpha as the frame
				updateAutoShot()
			end
		end		
	elseif event == "PLAYER_REGEN_ENABLED" then
		combatActive = false
	elseif event == "PLAYER_REGEN_DISABLED" then
		combatActive = true
	elseif event == "PLAYER_ENTERING_WORLD" then
		destroyIconTimers() -- Timers should be cleaned up regularly here.
		frame:ApplyOptions()
		powerMax = UnitPowerMax("player")
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
		currentTree = GetPrimaryTalentTree()

		if currentTree == nil then currentTree = 1 end

		destroyIconTimers()

		frame:ApplyOptions()
	else
		powerMax_new = UnitPowerMax("player")

		if powerMax_new ~= powerMax then
			powerMax = powerMax_new
			frame:SetMinMaxValues(0, powerMax)
		end
	end
end)
