--[[ Channel Names ]]--
local gsub = _G.string.gsub
local date = _G.date
local pairs = _G.pairs
local newAddMsg = {}

local channels = {
	["%[%d+%. WorldDefense%]"] = "WD",
	["%[%d+%. LookingForGroup%]"] = "LFG",
	["%[%d+%. General%]"] = "1",
	["%[%d+%. LocalDefense%]"] = "LD",
	["%[%d+%. Trade%]"] = "2",
	["%[%d+%. GuildRecruitment %- .*%]"] = "GR",
   ["%[%d+%. Dungeon Guide%]"] = "DG",
}

local function AddMessage(frame, text, ...)
	for k, v in pairs(channels) do
		text = gsub(text, k, v)
	end
   
	text = gsub(text, "%[(%d+)%. %w+%]", "[%1]")
	return newAddMsg[frame:GetName()](frame, text, ...)
end

do	for i = 1, NUM_CHAT_WINDOWS do
	if i ~= 2 then
		local f = _G[format("%s%d", "ChatFrame", i)]
		newAddMsg[format("%s%d", "ChatFrame", i)] = f.AddMessage
		f.AddMessage = AddMessage
	end
end

CHAT_GUILD_GET = "|Hchannel:Guild|hG|h %s "
CHAT_RAID_GET = "|Hchannel:raid|hR|h %s "
CHAT_PARTY_GET = "|Hchannel:Party|hP|h %s "
CHAT_PARTY_LEADER_GET = "|Hchannel:Party|hPL|h %s "
CHAT_RAID_WARNING_GET = "RW %s "
CHAT_RAID_LEADER_GET = "|Hchannel:raid|hRL|h %s "
CHAT_OFFICER_GET = "|Hchannel:o|hO|h %s "
CHAT_BATTLEGROUND_GET = "|Hchannel:Battleground|hBG|h %s "
CHAT_BATTLEGROUND_LEADER_GET = "|Hchannel:Battleground|hBGL|h %s "
CHAT_WHISPER_INFORM_GET = "To %s "
CHAT_WHISPER_GET = "%s whispers: "
CHAT_SAY_GET = "%s "
CHAT_YELL_GET = "%s "
CHAT_FLAG_AFK = "AFK! "
CHAT_FLAG_DND = "DND! "
CHAT_FLAG_GM = "GM! "
end
--[[ End of Channel Names ]]--