local function formatmem(t)	
	if t > 1024 then
		return (floor(t/10.24)/100).." MB"
	else
		return floor(t).." KB"
	end
end

LibStub("ncDatatext"):Create("FPS", {
	x = 585,
	y = -378,
   fontsize = 9,
	content = function()
		return "FPS: "..floor(GetFramerate())
	end,
})

LibStub("ncDatatext"):Create("Latency", {
	x = 525,
	y = -378,
   fontsize = 9,
	content = function()
		return select(3, GetNetStats()).." MS"
	end,
})

LibStub("ncDatatext"):Create("Memory", {
	x = 465,
	y = -378,
   fontsize = 9,
   content = function()
	local t = 0
	UpdateAddOnMemoryUsage()
	for i=1, GetNumAddOns(), 1 do
		t = t + GetAddOnMemoryUsage(i)
	end
		return formatmem(t)
	end,
	onclick = function()
		collectgarbage("collect")
	end,
	tooltip = {
		function()
			local total, mem, memory
			memory = {}
			UpdateAddOnMemoryUsage()
			total = 0
			for i = 1, GetNumAddOns() do
				mem = GetAddOnMemoryUsage(i)
				memory[i] = { select(2, GetAddOnInfo(i)), mem, IsAddOnLoaded(i) }
				total = total + mem
			end
		
			table.sort(memory, function(a, b)
				if a and b then
					return a[2] > b[2]
				end
			end)
				
			GameTooltip:AddDoubleLine("Memory usage:", formatmem(total))
			for i = 1, #memory do
				if memory[i][3] then
					GameTooltip:AddDoubleLine(memory[i][1], formatmem(memory[i][2]))
				end
			end
		end,
   }
})

LibStub("ncDatatext"):Create("Mail", {
	x = -375,
	y = -378,
   fontsize = 9,
	content = function()
		local mail = (HasNewMail() or 0)
		if mail>0 then
			return "You've got mail"
		else
			return "No new mail"
		end
      CheckInbox()
	end,
})

LibStub("ncDatatext"):Create("Bag", {
   x = -477.5,
   y = -378,
   fontsize = 9,
	content = function()
		local totfree = 0
		for i=0,4 do
			totfree = totfree + GetContainerNumFreeSlots(i)
		end
		return totfree.." free"
		end,
		onclick = function()
         OpenAllBags()
	end,   
})

LibStub("ncDatatext"):Create("Dura", {
	x = -580,
	y = -378,
   fontsize = 9,
   content = function()
		local curDur, maxDur = 0,0
		for i = 1, 20 do
			local curD, maxD = GetInventoryItemDurability(i)
			if maxD then
				curDur = curDur + curD
				maxDur = maxDur + maxD
			end
		end
         if maxDur==0 then
            return "100% dur"
         else
            return "Armor: "..floor((curDur/maxDur)*100).."%"
         end
		end,
		onclick = function()
			ToggleCharacter("PaperDollFrame")
	end,
})