local lib = LibStub:NewLibrary("ncDatatext", 1)
if not lib then return end
function lib:Create(name, tab)
	assert(type(tab) == "table", "ncDatatext: Bad arguments given, for reference look at the config file.")
	assert(type(tab.content) == "function", "ncDatatext: Content must be a function, the value of the frame is the return value of the function.")
	local f = CreateFrame("Frame", name)
	local t, rate, font, fontsize, anchor, parent, x, y, flags, event, content, onclick = f:CreateFontString(nil, "OVERLAY"), tab.rate or 1, tab.font or "Fonts\\FRIZQT__.ttf", tab.fontsize or 8, tab.anchor or "CENTER", tab.parent or "UIParent", tab.x or 0, tab.y or 0, tab.flags or "", tab.event or nil, tab.content or function() return "" end, tab.onclick or nil
	t:SetFont(font, fontsize, flags)
	f:SetPoint(anchor, parent, anchor, x, y)
	t:SetPoint("CENTER", f)
	function f:Update(self, event, ...)
		t:SetText(content(self, event, ...))			
		f:SetHeight(t:GetStringHeight())
		f:SetWidth(t:GetStringWidth())
	end
	if tab.onclick then
		f:EnableMouse(true)
		f:SetScript("OnMouseDown", function(self, button)
			onclick(button)
		end)
	end
	if event then
		f:SetScript("OnEvent", function()
			f:Update()
		end)
		f:RegisterEvent(event)
		f:Update()
	else		
		f.elapsed = 0
		f:SetScript("OnUpdate", function(self, elapsed)
			f.elapsed = f.elapsed + elapsed
			if (f.elapsed>rate) then
				f.elapsed = 0
				f:Update()
			end
		end)
		f:Update()
	end
end